Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::HighLevelGpuProgram Class Reference

Abstract base class representing a high-level program (a vertex or fragment program). More...

`#include <OgreHighLevelGpuProgram.h>`

Inheritance diagram for Ogre::HighLevelGpuProgram:

[legend]
List of all members.

## Public Types
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING }
| Enum identifying the loading state of the resource. More...
## Public Member Functions
| HighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~HighLevelGpuProgram ()
GpuProgramParametersSharedPtr | createParameters (void)
| Creates a new parameters object compatible with this program definition.
GpuProgram * | _getBindingDelegate (void)
const GpuNamedConstants & | getConstantDefinitions () const
| Get the full list of GpuConstantDefinition instances.
virtual void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
virtual void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
virtual const String & | getSyntaxCode (void) const
| Gets the syntax code for this program e.g.
virtual void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
virtual const String & | getSourceFile (void) const
| Gets the name of the file used as source for this program.
virtual const String & | getSource (void) const
| Gets the assembler source for this program.
virtual void | setType (GpuProgramType t)
| Set the program type (only valid before load).
virtual GpuProgramType | getType (void) const
| Get the program type.
virtual bool | isSupported (void) const
| Returns whether this program can be supported on the current renderer and hardware.
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform skeletal animation.
virtual bool | isSkeletalAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform skeletal animation.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform morph animation.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program includes the required instructions to perform pose animation.
virtual bool | isMorphAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform morph animation.
virtual bool | isPoseAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform pose animation.
virtual ushort | getNumberOfPosesIncluded (void) const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
virtual bool | isVertexTextureFetchRequired (void) const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
virtual GpuProgramParametersSharedPtr | getDefaultParameters (void)
| Get a reference to the default parameters which are to be used for all uses of this program.
virtual bool | hasDefaultParameters (void) const
| Returns true if default parameters have been set up.
virtual void | setSurfaceAndPassLightStates (bool state)
| Sets whether a vertex program requires light and material states to be passed to through fixed pipeline low level API rendering calls.
virtual bool | getPassSurfaceAndLightStates (void) const
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls.
virtual const String & | getLanguage (void) const
| Returns a string that specifies the language of the gpu programs as specified in a material script.
virtual bool | hasCompileError (void) const
| Did this program encounter a compile error when loading?
virtual void | resetCompileError (void)
| Reset a compile error if it occurred, allowing the load to be retried.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
const String & | getName (void) const
| Gets resource name.
ResourceHandle | getHandle (void) const
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
LoadingState | isLoading () const
| Returns whether the resource is currently in the process of background loading.
LoadingState | getLoadingState () const
| Returns the current loading state.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
void | escalateLoading ()
| Escalates the loading of a background loaded resource.
void | addListener (Listener *lis)
| Register a listener on this resource.
void | removeListener (Listener *lis)
| Remove a listener on this resource.
const String & | getGroup (void)
| Gets the group which this resource is a member of.
void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | _fireBackgroundLoadingComplete (void)
| Firing of background loading complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Protected Types
typedef std::list< Listener * > | ListenerList
## Protected Member Functions
virtual void | loadHighLevel (void)
| Internal load high-level portion if not loaded.
virtual void | unloadHighLevel (void)
| Internal unload high-level portion if loaded.
virtual void | loadHighLevelImpl (void)
| Internal load implementation, loads just the high-level portion, enough to get parameters.
virtual void | createLowLevelImpl (void)=0
| Internal method for creating an appropriate low-level program from this high-level program, must be implemented by subclasses.
virtual void | unloadHighLevelImpl (void)=0
| Internal unload implementation, must be implemented by subclasses.
virtual void | populateParameterNames (GpuProgramParametersSharedPtr params)
| Populate the passed parameters with name->index map.
virtual void | buildConstantDefinitions () const =0
| Build the constant definition map, must be overridden.
void | loadImpl ()
void | unloadImpl ()
void | setupBaseParamDictionary (void)
| Internal method for setting up the basic parameter definitions for a subclass.
bool | isRequiredCapabilitiesSupported (void) const
| Internal method returns whether required capabilities for this program is supported.
size_t | calculateSize (void) const
virtual void | loadFromSource (void)=0
| Virtual method which must be implemented by subclasses, load from mSource.
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
virtual void | queueFireBackgroundLoadingComplete (void)
| Queue the firing of background loading complete event.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
bool | mHighLevelLoaded
| Whether the high-level program (and it's parameter defs) is loaded.
GpuProgramPtr | mAssemblerProgram
| The underlying assembler program.
bool | mConstantDefsBuilt
| Have we built the name->index parameter map yet?
GpuNamedConstants | mConstantDefs
| Parameter name -> ConstantDefinition map, shared instance used by all parameter objects.
GpuProgramType | mType
| The type of the program.
String | mFilename
| The name of the file to load source from (may be blank).
String | mSource
| The assembler source of the program (may be blank until file loaded).
bool | mLoadFromFile
| Whether we need to load source from file or not.
String | mSyntaxCode
| Syntax code eg arbvp1, vs_2_0 etc.
bool | mSkeletalAnimation
| Does this (vertex) program include skeletal animation?
bool | mMorphAnimation
| Does this (vertex) program include morph animation?
ushort | mPoseAnimation
| Does this (vertex) program include pose animation (count of number of poses supported).
bool | mVertexTextureFetch
| Does this (vertex) program require support for vertex texture fetch?
GpuProgramParametersSharedPtr | mDefaultParams
| The default parameters for use with this object.
bool | mPassSurfaceAndLightStates
| Does this program want light states passed through fixed pipeline.
bool | mCompileError
| Did we encounter a compilation error?
GpuLogicalBufferStruct | mFloatLogicalToPhysical
| Record of logical to physical buffer maps.
GpuLogicalBufferStruct | mIntLogicalToPhysical
| Record of logical to physical buffer maps.
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
volatile LoadingState | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| Mutex to cover the status of loading The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
ListenerList | mListenerList
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).
## Static Protected Attributes
static CmdType | msTypeCmd
static CmdSyntax | msSyntaxCmd
static CmdSkeletal | msSkeletalCmd
static CmdMorph | msMorphCmd
static CmdPose | msPoseCmd
static CmdVTF | msVTFCmd
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Detailed Description

Abstract base class representing a high-level program (a vertex or fragment program).

Remarks:
  High-level programs are vertex and fragment programs written in a high-level language such as Cg or HLSL, and as such do not require you to write assembler code like GpuProgram does. However, the high-level program does eventually get converted (compiled) into assembler and then eventually microcode which is what runs on the GPU. As well as the convenience, some high-level languages like Cg allow you to write a program which will operate under both Direct3D and OpenGL, something which you cannot do with just GpuProgram (which requires you to write 2 programs and use each in a Technique to provide cross-API compatibility). Ogre will be creating a GpuProgram for you based on the high-level program, which is compiled specifically for the API being used at the time, but this process is transparent.

  You cannot create high-level programs direct - use HighLevelGpuProgramManager instead. Plugins can register new implementations of HighLevelGpuProgramFactory in order to add support for new languages without requiring changes to the core Ogre API. To allow custom parameters to be set, this class extends StringInterface - the application can query on the available custom parameters and get/set them without having to link specifically with it.

Definition at line 58 of file OgreHighLevelGpuProgram.h.

## Member Typedef Documentation

typedef std::list<Listener*> Ogre::Resource::ListenerList`[protected, inherited]`

| Definition at line 131 of file OgreResource.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

  | Enum identifying the loading state of the resource. Enumeration values:
  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.
Definition at line 96 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::HighLevelGpuProgram::HighLevelGpuProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`
| ) |

| Constructor, should be used only by factory classes.

Ogre::HighLevelGpuProgram::~HighLevelGpuProgram | ( |  | ) |

## Member Function Documentation

virtual void Ogre::Resource::_fireBackgroundLoadingComplete | ( | void |  | ) | `[virtual, inherited]`

| Firing of background loading complete event. Remarks: You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

GpuProgram* Ogre::HighLevelGpuProgram::_getBindingDelegate | ( | void |  | ) | `[virtual]`

| Reimplemented from Ogre::GpuProgram. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 113 of file OgreHighLevelGpuProgram.h.

void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[inherited]`

| Notify this resource of it's origin. Definition at line 358 of file OgreResource.h.

void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[inherited]`

| Register a listener on this resource. See also: Resource::Listener Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::HighLevelGpuProgram::buildConstantDefinitions | ( |  | ) | const`[protected, pure virtual]`

| Build the constant definition map, must be overridden. Note: The implementation must fill in the mConstantDefs field at a minimum, and if the program requires that parameters are bound using logical parameter indexes then the mFloatLogicalToPhysical and mIntLogicalToPhysical maps must also be populated. Implemented in Ogre::UnifiedHighLevelGpuProgram.

size_t Ogre::GpuProgram::calculateSize | ( | void |  | ) | const`[protected, virtual, inherited]`

| Implements Ogre::Resource. Definition at line 1402 of file OgreGpuProgram.h.

void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[inherited]`

  | Change the resource group ownership of a Resource. Remarks: This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another. Parameters:
  | newGroup | Name of the new group

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

  | Method for copying this object's parameters to another object. Remarks: This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop. Any unrecognised parameters will be ignored as with setParameter method. Parameters:
  | dest | Pointer to object to have it's parameters set the same as this object.
Definition at line 300 of file OgreStringInterface.h. References Ogre::ParamDictionary::mParamDefs.

virtual void Ogre::HighLevelGpuProgram::createLowLevelImpl | ( | void |  | ) | `[protected, pure virtual]`

| Internal method for creating an appropriate low-level program from this high-level program, must be implemented by subclasses. Implemented in Ogre::UnifiedHighLevelGpuProgram.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

  | Internal method for creating a parameter dictionary for the class, if it does not already exist. Remarks: This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance). Parameters:
  | className | the name of the class using the dictionary
Returns: true if a new dictionary was created, false if it was already there Definition at line 176 of file OgreStringInterface.h.

GpuProgramParametersSharedPtr Ogre::HighLevelGpuProgram::createParameters | ( | void |  | ) | `[virtual]`

| Creates a new parameters object compatible with this program definition. Remarks: Unlike low-level assembly programs, parameters objects are specific to the program and therefore must be created from it rather than by the HighLevelGpuProgramManager. This method creates a new instance of a parameters object containing the definition of the parameters this program understands. Reimplemented from Ogre::GpuProgram. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Resource::escalateLoading | ( |  | ) | `[inherited]`

| Escalates the loading of a background loaded resource. Remarks: If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

const GpuNamedConstants& Ogre::HighLevelGpuProgram::getConstantDefinitions | ( |  | ) | const

| Get the full list of GpuConstantDefinition instances. Note: Only available if this parameters object has named parameters.

ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[inherited]`

| Gets the manager which created this resource. Definition at line 349 of file OgreResource.h.

virtual GpuProgramParametersSharedPtr Ogre::GpuProgram::getDefaultParameters | ( | void |  | ) | `[virtual, inherited]`

| Get a reference to the default parameters which are to be used for all uses of this program. Remarks: A program can be set up with a list of default parameters, which can save time when using a program many times in a material with roughly the same settings. By retrieving the default parameters and populating it with the most used options, any new parameter objects created from this program afterwards will automatically include the default parameters; thus users of the program need only change the parameters which are unique to their own usage of the program. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

const String& Ogre::Resource::getGroup | ( | void |  | ) | `[inherited]`

| Gets the group which this resource is a member of. Reimplemented in Ogre::SkeletonInstance. Definition at line 337 of file OgreResource.h.

ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[inherited]`

| Reimplemented in Ogre::SkeletonInstance. Definition at line 263 of file OgreResource.h.

virtual const String& Ogre::GpuProgram::getLanguage | ( | void |  | ) | const`[virtual, inherited]`

| Returns a string that specifies the language of the gpu programs as specified in a material script. ie: asm, cg, hlsl, glsl Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[inherited]`

| Returns the current loading state. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 286 of file OgreResource.h.

const String& Ogre::Resource::getName | ( | void |  | ) | const`[inherited]`

| Gets resource name. Reimplemented in Ogre::SkeletonInstance. Definition at line 258 of file OgreResource.h.

virtual ushort Ogre::GpuProgram::getNumberOfPosesIncluded | ( | void |  | ) | const`[virtual, inherited]`

| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation. Definition at line 1512 of file OgreGpuProgram.h.

const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[inherited]`

| Get the origin of this resource, e.g. a script file name. Remarks: This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it. Definition at line 356 of file OgreResource.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 213 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

| Retrieves the parameter dictionary for this class. Remarks: Only valid to call this after createParamDictionary. Returns: Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc. Definition at line 200 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

  | Generic parameter retrieval method. Remarks: Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type. Parameters:
  | name | The name of the parameter to get
Returns: String value of parameter, blank if not found Definition at line 269 of file OgreStringInterface.h. References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

| Retrieves a list of parameters valid for this object. Returns: A reference to a static list of ParameterDef objects.

virtual bool Ogre::GpuProgram::getPassSurfaceAndLightStates | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1552 of file OgreGpuProgram.h.

size_t Ogre::Resource::getSize | ( | void |  | ) | const`[inherited]`

| Retrieves info about the size of the resource. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 247 of file OgreResource.h.

virtual const String& Ogre::GpuProgram::getSource | ( | void |  | ) | const`[virtual, inherited]`

| Gets the assembler source for this program. Definition at line 1434 of file OgreGpuProgram.h.

virtual const String& Ogre::GpuProgram::getSourceFile | ( | void |  | ) | const`[virtual, inherited]`

| Gets the name of the file used as source for this program. Definition at line 1432 of file OgreGpuProgram.h.

virtual const String& Ogre::GpuProgram::getSyntaxCode | ( | void |  | ) | const`[virtual, inherited]`

| Gets the syntax code for this program e.g. arbvp1, fp20, vs_1_1 etc Definition at line 1426 of file OgreGpuProgram.h.

virtual GpuProgramType Ogre::GpuProgram::getType | ( | void |  | ) | const`[virtual, inherited]`

| Get the program type. Definition at line 1438 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::hasCompileError | ( | void |  | ) | const`[virtual, inherited]`

| Did this program encounter a compile error when loading? Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1561 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::hasDefaultParameters | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if default parameters have been set up. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1536 of file OgreGpuProgram.h.

bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[inherited]`

| Returns whether this Resource has been earmarked for background loading. Remarks: This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 303 of file OgreResource.h.

bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource has been loaded, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 270 of file OgreResource.h.

LoadingState Ogre::Resource::isLoading | ( |  | ) | const`[inherited]`

| Returns whether the resource is currently in the process of background loading. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 279 of file OgreResource.h.

bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[inherited]`

| Is this resource manually loaded? Definition at line 235 of file OgreResource.h.

virtual bool Ogre::GpuProgram::isMorphAnimationIncluded | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether a vertex program includes the required instructions to perform morph animation. Remarks: If this returns true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1500 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::isPoseAnimationIncluded | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether a vertex program includes the required instructions to perform pose animation. Remarks: If this returns true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1508 of file OgreGpuProgram.h.

bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource is reloadable, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 228 of file OgreResource.h.

bool Ogre::GpuProgram::isRequiredCapabilitiesSupported | ( | void |  | ) | const`[protected, inherited]`

| Internal method returns whether required capabilities for this program is supported.

virtual bool Ogre::GpuProgram::isSkeletalAnimationIncluded | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether a vertex program includes the required instructions to perform skeletal animation. Remarks: If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1473 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::isSupported | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether this program can be supported on the current renderer and hardware. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual bool Ogre::GpuProgram::isVertexTextureFetchRequired | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether this vertex program requires support for vertex texture fetch from the hardware. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1520 of file OgreGpuProgram.h.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

  | Loads the resource, if it is not already. Remarks: If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own. Parameters:
  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.
Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::GpuProgram::loadFromSource | ( | void |  | ) | `[protected, pure virtual, inherited]`

| Virtual method which must be implemented by subclasses, load from mSource. Implemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::HighLevelGpuProgram::loadHighLevel | ( | void |  | ) | `[protected, virtual]`

| Internal load high-level portion if not loaded.

virtual void Ogre::HighLevelGpuProgram::loadHighLevelImpl | ( | void |  | ) | `[protected, virtual]`

| Internal load implementation, loads just the high-level portion, enough to get parameters.

void Ogre::HighLevelGpuProgram::loadImpl | ( |  | ) | `[protected, virtual]`

| Reimplemented from Ogre::GpuProgram.

virtual void Ogre::HighLevelGpuProgram::populateParameterNames | ( | GpuProgramParametersSharedPtr | params | ) | `[protected, virtual]`

| Populate the passed parameters with name->index map.

virtual void Ogre::Resource::postLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded. Note: Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called) Reimplemented in Ogre::Mesh. Definition at line 156 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded. Note: Mutex will have already been acquired by the unloading thread. Definition at line 166 of file OgreResource.h.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'. Note: Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called) Definition at line 149 of file OgreResource.h.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal hook to perform actions before the unload process. Note: Mutex will have already been acquired by the unloading thread. Definition at line 161 of file OgreResource.h.

virtual void Ogre::Resource::queueFireBackgroundLoadingComplete | ( | void |  | ) | `[protected, virtual, inherited]`

| Queue the firing of background loading complete event.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

| Reloads the resource, if it is already loaded. Remarks: Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[inherited]`

| Remove a listener on this resource. See also: Resource::Listener Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::GpuProgram::resetCompileError | ( | void |  | ) | `[virtual, inherited]`

| Reset a compile error if it occurred, allowing the load to be retried. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 1565 of file OgreGpuProgram.h.

void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[inherited]`

| Tells the resource whether it is background loaded or not. Remarks: See also: Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself). Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 313 of file OgreResource.h.

virtual void Ogre::GpuProgram::setMorphAnimationIncluded | ( | bool | included | ) | `[virtual, inherited]`

| Sets whether a vertex program includes the required instructions to perform morph animation. Remarks: If this is set to true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it. Definition at line 1481 of file OgreGpuProgram.h.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

  | Generic parameter setting method. Remarks: Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters. Parameters:
  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.
Returns: true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

  | Generic multiple parameter setting method. Remarks: Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters. Parameters:
  | paramList | Name/value pair list

virtual void Ogre::GpuProgram::setPoseAnimationIncluded | ( | ushort | poseCount | ) | `[virtual, inherited]`

  | Sets whether a vertex program includes the required instructions to perform pose animation. Remarks: If this is set to true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it. Parameters:
  | poseCount | The number of simultaneous poses the program can blend
Definition at line 1491 of file OgreGpuProgram.h.

virtual void Ogre::GpuProgram::setSkeletalAnimationIncluded | ( | bool | included | ) | `[virtual, inherited]`

| Sets whether a vertex program includes the required instructions to perform skeletal animation. Remarks: If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it. Definition at line 1464 of file OgreGpuProgram.h.

virtual void Ogre::GpuProgram::setSource | ( | const String & | source | ) | `[virtual, inherited]`

| Sets the source assembly for this program from an in-memory string. Remarks: Setting this will have no effect until you (re)load the program.

virtual void Ogre::GpuProgram::setSourceFile | ( | const String & | filename | ) | `[virtual, inherited]`

| Sets the filename of the source assembly for this program. Remarks: Setting this will have no effect until you (re)load the program.

virtual void Ogre::GpuProgram::setSurfaceAndPassLightStates | ( | bool | state | ) | `[virtual, inherited]`

| Sets whether a vertex program requires light and material states to be passed to through fixed pipeline low level API rendering calls. Remarks: If this is set to true, OGRE will pass all active light states to the fixed function pipeline. This is useful for high level shaders like GLSL that can read the OpenGL light and material states. This way the user does not have to use autoparameters to pass light position, color etc. Definition at line 1546 of file OgreGpuProgram.h.

virtual void Ogre::GpuProgram::setSyntaxCode | ( | const String & | syntax | ) | `[virtual, inherited]`

| Sets the syntax code for this program e.g. arbvp1, fp20, vs_1_1 etc

virtual void Ogre::GpuProgram::setType | ( | GpuProgramType | t | ) | `[virtual, inherited]`

| Set the program type (only valid before load).

void Ogre::GpuProgram::setupBaseParamDictionary | ( | void |  | ) | `[protected, inherited]`

| Internal method for setting up the basic parameter definitions for a subclass. Remarks: Because StringInterface holds a dictionary of parameters per class, subclasses need to call this to ask the base class to add it's parameters to their dictionary as well. Can't do this in the constructor because that runs in a non-virtual context. The subclass must have called it's own createParamDictionary before calling this method.

virtual void Ogre::GpuProgram::setVertexTextureFetchRequired | ( | bool | r | ) | `[virtual, inherited]`

| Sets whether this vertex program requires support for vertex texture fetch from the hardware. Definition at line 1516 of file OgreGpuProgram.h.

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual, inherited]`

| 'Touches' the resource to indicate it has been used. Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

| Unloads the resource; this is not permanent, the resource can be reloaded later if required. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::HighLevelGpuProgram::unloadHighLevel | ( | void |  | ) | `[protected, virtual]`

| Internal unload high-level portion if loaded.

virtual void Ogre::HighLevelGpuProgram::unloadHighLevelImpl | ( | void |  | ) | `[protected, pure virtual]`

| Internal unload implementation, must be implemented by subclasses. Implemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::HighLevelGpuProgram::unloadImpl | ( |  | ) | `[protected, virtual]`

| Implements Ogre::Resource.

## Member Data Documentation

GpuProgramPtr Ogre::HighLevelGpuProgram::mAssemblerProgram`[protected]`

| The underlying assembler program. Definition at line 64 of file OgreHighLevelGpuProgram.h.

bool Ogre::GpuProgram::mCompileError`[protected, inherited]`

| Did we encounter a compilation error? Definition at line 1379 of file OgreGpuProgram.h.

GpuNamedConstants Ogre::HighLevelGpuProgram::mConstantDefs`[mutable, protected]`

| Parameter name -> ConstantDefinition map, shared instance used by all parameter objects. Definition at line 68 of file OgreHighLevelGpuProgram.h.

bool Ogre::HighLevelGpuProgram::mConstantDefsBuilt`[mutable, protected]`

| Have we built the name->index parameter map yet? Definition at line 66 of file OgreHighLevelGpuProgram.h.

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

| Creator. Definition at line 109 of file OgreResource.h.

GpuProgramParametersSharedPtr Ogre::GpuProgram::mDefaultParams`[protected, inherited]`

| The default parameters for use with this object. Definition at line 1375 of file OgreGpuProgram.h.

String Ogre::GpuProgram::mFilename`[protected, inherited]`

| The name of the file to load source from (may be blank). Definition at line 1359 of file OgreGpuProgram.h.

GpuLogicalBufferStruct Ogre::GpuProgram::mFloatLogicalToPhysical`[mutable, protected, inherited]`

| Record of logical to physical buffer maps. Mandatory for low-level programs or high-level programs which set their params the same way. Definition at line 1382 of file OgreGpuProgram.h.

String Ogre::Resource::mGroup`[protected, inherited]`

| The name of the resource group. Definition at line 113 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

| Numeric handle for more efficient look up than name. Definition at line 115 of file OgreResource.h.

bool Ogre::HighLevelGpuProgram::mHighLevelLoaded`[protected]`

| Whether the high-level program (and it's parameter defs) is loaded. Definition at line 62 of file OgreHighLevelGpuProgram.h.

GpuLogicalBufferStruct Ogre::GpuProgram::mIntLogicalToPhysical`[mutable, protected, inherited]`

| Record of logical to physical buffer maps. Mandatory for low-level programs or high-level programs which set their params the same way. Definition at line 1385 of file OgreGpuProgram.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

| Is this resource going to be background loaded? Only applicable for multithreaded. Definition at line 119 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

| Is this file manually loaded? Definition at line 125 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

| Definition at line 132 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

| Optional manual loader; if provided, data is loaded from here instead of a file. Definition at line 129 of file OgreResource.h.

bool Ogre::GpuProgram::mLoadFromFile`[protected, inherited]`

| Whether we need to load source from file or not. Definition at line 1363 of file OgreGpuProgram.h.

volatile LoadingState Ogre::Resource::mLoadingState`[protected, inherited]`

| Is the resource currently loaded? Definition at line 117 of file OgreResource.h.

bool Ogre::GpuProgram::mMorphAnimation`[protected, inherited]`

| Does this (vertex) program include morph animation? Definition at line 1369 of file OgreGpuProgram.h.

String Ogre::Resource::mName`[protected, inherited]`

| Unique name of the resource. Definition at line 111 of file OgreResource.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

| Origin of this resource (e.g. script name) - optional. Definition at line 127 of file OgreResource.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 164 of file OgreStringInterface.h.

bool Ogre::GpuProgram::mPassSurfaceAndLightStates`[protected, inherited]`

| Does this program want light states passed through fixed pipeline. Definition at line 1377 of file OgreGpuProgram.h.

ushort Ogre::GpuProgram::mPoseAnimation`[protected, inherited]`

| Does this (vertex) program include pose animation (count of number of poses supported). Definition at line 1371 of file OgreGpuProgram.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

| Dictionary of parameters. Definition at line 161 of file OgreStringInterface.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

| Mutex to cover the status of loading The size of the resource in bytes. Definition at line 123 of file OgreResource.h.

bool Ogre::GpuProgram::mSkeletalAnimation`[protected, inherited]`

| Does this (vertex) program include skeletal animation? Definition at line 1367 of file OgreGpuProgram.h.

CmdMorph Ogre::GpuProgram::msMorphCmd`[static, protected, inherited]`

| Definition at line 1352 of file OgreGpuProgram.h.

String Ogre::GpuProgram::mSource`[protected, inherited]`

| The assembler source of the program (may be blank until file loaded). Definition at line 1361 of file OgreGpuProgram.h.

CmdPose Ogre::GpuProgram::msPoseCmd`[static, protected, inherited]`

| Definition at line 1353 of file OgreGpuProgram.h.

CmdSkeletal Ogre::GpuProgram::msSkeletalCmd`[static, protected, inherited]`

| Definition at line 1351 of file OgreGpuProgram.h.

CmdSyntax Ogre::GpuProgram::msSyntaxCmd`[static, protected, inherited]`

| Definition at line 1350 of file OgreGpuProgram.h.

CmdType Ogre::GpuProgram::msTypeCmd`[static, protected, inherited]`

| Definition at line 1349 of file OgreGpuProgram.h.

CmdVTF Ogre::GpuProgram::msVTFCmd`[static, protected, inherited]`

| Definition at line 1354 of file OgreGpuProgram.h.

String Ogre::GpuProgram::mSyntaxCode`[protected, inherited]`

| Syntax code eg arbvp1, vs_2_0 etc. Definition at line 1365 of file OgreGpuProgram.h.

GpuProgramType Ogre::GpuProgram::mType`[protected, inherited]`

| The type of the program. Definition at line 1357 of file OgreGpuProgram.h.

bool Ogre::GpuProgram::mVertexTextureFetch`[protected, inherited]`

| Does this (vertex) program require support for vertex texture fetch? Definition at line 1373 of file OgreGpuProgram.h.

The documentation for this class was generated from the following file:

- OgreHighLevelGpuProgram.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:53 2008